/* Example 12-2.c */

/* NOTES:
 *
 * This program calculates the difference between two times.
 *
 * Given:  Start time and End time are specified in 24 hour format
 *         Start time and End time do NOT span days
 */

#include <stdio.h>

/* define a time_struct */
struct time_struct {
    int hour;
    int minute;
};

/* create a new type: 'time' */
typedef struct time_struct time;

/* function prototypes */
time timediff(time, time);

/* define a macro -- this is inline code */
/* inline code runs faster since there is no overhead of a function call */
/* NOTE:  NO trailing ; on the define! */
#define printtime(t) printf("%d:%02d", t.hour, t.minute)

int main()
{
    time t1 = { 12, 40 };
    time t2 = { 18, 30 };

    time t3;

    t3 = timediff(t1, t2);

    printf("Start: ");
    printtime(t1);
    printf("   End: ");
    printtime(t2);
    printf("   Diff: ");
    printtime(t3);

    return(0);
}

time timediff(time start, time end)
{
    int h, m;
    time ret;

    h = end.hour - start.hour;
    m = end.minute - start.minute;

    if (m < 0) {
        m += 60;
        h --;
    }

    ret.hour = h;
    ret.minute = m;

    return(ret);
}
