/* Example 8-1a.c */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

int char_count[256] = {0};  /* allocate array large enough to represent         */
                            /* entire valid character range                     */
                            /* the {} will initialize 0 elements of the array   */
                            /* the balance of the array will be set to 0        */

char ch, buf[100];
int pos;

int main()
{
    /* read input 1 line at a time -- when EOF the while() loop will fail */
    while (fgets(buf, sizeof(buf), stdin)) {

        /* iterate through each character in the input string */
        for (pos = 0; pos < (int) strlen(buf); pos++) {
            /* tolower will ONLY change upper case letters to lower case --
                all other characters will not be affected */
            ch = (char) tolower(buf[pos]);

            /* increment the count for this character */
            char_count[ch]++;
        }
    }

    /* print out the results */
    for (ch = 'a'; ch <= 'z'; ch++)
        printf("Char '%c' -- %3d\n", ch, char_count[ch]);

    for (ch = '0'; ch <= '9'; ch++)
        printf("Char '%c' -- %3d\n", ch, char_count[ch]);

    return(0);
}
